import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.util.Scanner;

/*
 * GUI (Graphical User Interface), mit einem eigenen Layout
 */
public class LichtschalterGUI implements ActionListener {
    JButton[] buttonArray;
    JLabel lab1,lab2;
    JFrame frame;

    public void zeigeFenster() {
        setSchriftgroesse(16);

        frame = new JFrame();
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        frame.setTitle("Lichtschalter");
        frame.setLayout(null); 

        buttonArray = new JButton[2];
        
        JButton but = new JButton("Licht");
        but.setBackground(Color.blue);
        but.setBounds(10,10,110,40);
        but.addActionListener(this);
        frame.add( but );
        buttonArray[0] = but;
        
        but = new JButton("Licht");
        but.setBackground(Color.blue);
        but.setBounds(130,10,110,40);
        but.addActionListener(this);
        frame.add( but );
        buttonArray[1] = but;

        lab1 = new JLabel("Ziel ist es, alle Lichtschalter einzuschalten!");
        lab1.setBounds(10,60,450,40);
        frame.add(lab1);

        lab2 = new JLabel("Auf geht's!");
        lab2.setBounds(10,100,150,40);
        frame.add(lab2);

        frame.pack();
        frame.setSize(500,200);
        frame.setResizable(false);
        frame.setVisible( true );
    }

    public void switchLight(int idx) {
        if((idx >= 0) && (idx < buttonArray.length)) {
            if(buttonArray[idx].getBackground().equals(Color.blue)) {
                buttonArray[idx].setBackground(Color.yellow);
            } else {
                buttonArray[idx].setBackground(Color.blue);
            }
        } else {
            System.out.println("Achtung! Programmierfehler in Methode 'switchLight': Das Licht "+idx+" gibts nicht!");
        }
    }
    
    public boolean lightOn(int idx) {
        boolean result = false;
        if((idx >= 0) && (idx < buttonArray.length)) {
            if(buttonArray[idx].getBackground().equals(Color.yellow)) {
                result = true;
            }
        } else {
            System.out.println("Achtung! Programmierfehler in Methode 'lightOn': Das Licht "+idx+" gibts nicht!");
        }
        return result;
    }
    
    public void actionPerformed(ActionEvent e) {
        if(e.getSource() == buttonArray[0]) {
            switchLight(1);
        }
        if(e.getSource() == buttonArray[1]) {
            switchLight(0);
        }
        
        if(lightOn(0) && lightOn(1)) {
            lab2.setText("Super! Geschafft!");
        } else {
            lab2.setText("Weitermachen!");
        }
        
    }

    void setSchriftgroesse(int s) {
        Font f = new Font("Arial", Font.BOLD, s);

        UIManager.put("Button.font",f);
        UIManager.put("ToggleButton.font",f);
        UIManager.put("RadioButton.font", f);
        UIManager.put("CheckBox.font", f);
        UIManager.put("ColorChooser.font", f);
        UIManager.put("ComboBox.font", f);
        UIManager.put("Label.font",f);
        UIManager.put("List.font", f);
        UIManager.put("MenuBar.font", f);
        UIManager.put("MenuItem.font", f);
        UIManager.put("RadioButtonMenuItem.font", f);
        UIManager.put("CheckBoxMenuItem.font", f);
        UIManager.put("Menu.font", f);
        UIManager.put("PopupMenu.font", f);
        UIManager.put("OptionPane.font", f);
        UIManager.put("Panel.font", f);
        UIManager.put("ProgressBar.font", f);
        UIManager.put("ScrollPane.font", f);
        UIManager.put("Viewport.font", f);
        UIManager.put("TabbedPane.font", f);
        UIManager.put("Table.font", f);
        UIManager.put("TableHeader.font", f);
        UIManager.put("TextField.font", f);
        UIManager.put("PasswordField.font", f);
        UIManager.put("TextArea.font", f);
        UIManager.put("TextPane.font", f);
        UIManager.put("EditorPane.font", f);
        UIManager.put("TitledBorder.font", f);
        UIManager.put("ToolBar.font", f);
        UIManager.put("ToolTip.font", f);
        UIManager.put("Tree.font", f);        
    }

}